/*
 * Stupid simple Raytracer.
 */
import enerj.lang.*;

import java.awt.*;
import java.awt.image.*;
import java.io.*;


public class Plane {
    static int w,h;
    static float k; // what the hell is this variable for?
    static MemoryImageSource idx;
    static Image buffer;
    static @Approx(0.9) int pixels[];
    static int texture,light;
    // FIXME: lcoff ends up unconstrained.
    static @Approx(0.9) float lcoff;
    static float sng; // could maybe make approximate
    static int numIterations =0;

    public static void main(String[] args) {
        Dimension dd=new Dimension(400, 256);
        w=dd.width;
        h=dd.height;
        texture=Integer.parseInt(args[0]);//getParameter("texture"));
        light=Integer.parseInt(args[1]);//getParameter("light"));
        pixels=new @Approx int[w*h];
        int index,x,y; //not approx --> for loops and array indexing.
        @Approx float xe,ye,ze;
        @Dyn float xd, yd, zd;
        // This is annotated because they flow into pixels indirectly
        @Approx(0.9) float ix,iy,iz;
        @Approx float nx,ny,nz;
        // Removed @Approx annotation
        float lx,ly,lz;
        float lly;
        lly=Integer.parseInt(args[2]);//getParameter("lighty"));
        ye=Integer.parseInt(args[3]); //getParameter("viewy"));

        nx=0;
        ny=1;
        nz=0;
        int bl=(255<<24); // this stands for black, a constant, maybe?
        @Approx float t; //who knows
        // TODO: When benchmarking, consider using intermediate values instead of
        // dyn to compare and constrast dyn overhead
        @Dyn float l; //who knows, Dyn because it is set from *d, which are all dyn
        float w1,h1; //positioning in image? so don't make approx?
        w1=w/2;
        h1=h/2;

        xe=0;

        ze=0;
        k=-1;

        for(y=0;y<h;y++) {
            for(x=0;x<w;x++) {
                t=-1;
                xd=(x-w1)/w1;
                yd=(h1-y)/h1;
                zd=-1;
                l=xd*xd+yd*yd+zd*zd;
                xd = xd / l;
                yd = yd / l;
                zd = zd / l;

                if(Endorsements.checked_endorse((k-ye)*yd, 0.95)<=0) {
                    t=-1;
                } else {
                    t=(k-ye)/Endorsements.checked_endorse(yd, 0.95);
                }

                index=y*w+x;
                if(Endorsements.endorse(t)>=0) {
                    ix=xe+t*Endorsements.checked_endorse(xd, 0.95);
                    iy=ye+t*Endorsements.checked_endorse(yd, 0.95);
                    iz=ze+t*Endorsements.checked_endorse(zd, 0.95);
                    lx=0;
                    ly=lly;
                    lz=0;
                    lx=lx-Endorsements.endorse(ix);
                    ly=ly-Endorsements.endorse(iy);
                    lz=lz-Endorsements.endorse(iz);
                    // This cast to double seems redundant, but the Math.sqrt
                    // call will be wrapped to return a Double (Object), which
                    // can't be cast to a float (primative).
                    sng=(float)(double)Math.sqrt(lx*lx+ly*ly+lz*lz);
                    // sng=1.7f/sng;
                    sng=1.0f/sng;
                    lcoff=(lx*nx+ly*ny+lz*nz)*sng;
                    pixels[index]=texture(ix,iy,iz);
                } else {
                    pixels[index]=bl;
                }
             numIterations++;
            }
        }
        for (int i = 0; i < pixels.length; i++) {
            System.out.println(Endorsements.endorse(pixels[i] & 0xff)+"\n");
            System.out.println(Endorsements.endorse((pixels[i] >> 8) & 0xff)+"\n");
            System.out.println(Endorsements.endorse((pixels[i] >> 16) & 0xff)+"\n");
        }
        //checkErrors(pixels);
    }

    // DECAF: This warns that z is unconstrained, which is true because it only
    // flows into v through an endorse.  However, it's ok because it's not
    // modified in the method and it is passed in with a precision of 0.9
    public static @Approx int texture(@Approx float x,@Approx float y, @Approx float z) {
        int v;
        @Approx int col;
        @Approx int r,b;
        r=255;
        b=0;
        col=0;
        if(light!=0) {
            @Approx(0.9) float floatR = 255 * lcoff;
            r= (@Approx int) floatR;
        }
        b=r;

        if(texture==1) {
            col=(255<<24)|(255<<16);
        } else if(texture==2) {
            v=(Math.round(Endorsements.endorse(x))+Math.round(Endorsements.endorse(z))) %2;
            if(v==0) {
                col=(255<<24)|b;
            } else {
                col=(255<<24)|(r<<16);
            }
        }

        if(numIterations == 25) {
            System.gc();
        }
        return col;
    }

    /*
    public static void main(String[] args) {
        Plane p = new Plane();
        p.init(args);
    }
    */

    public void checkErrors(@Approx int[] pixels) {

        // for kicks, so we can see what the result looked like, we serialize it to a file.
        try {
            ObjectOutputStream out = new ObjectOutputStream(new FileOutputStream("result.ser"));
            out.writeObject(pixels);
            out.flush();
            out.close();
        } catch (Exception e) {e.printStackTrace();}


        int[] referenceImage = new int[0];
        try{
            // Deserialize the reference int[]
            ObjectInputStream in = new ObjectInputStream(new FileInputStream("reference.ser"));
            referenceImage = (int[]) in.readObject();
            in.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }

        int diff = 0;
        for (int i = 0; i < pixels.length; i++) {
            // count absolute RGB differences
            diff += Math.abs((Endorsements.endorse(pixels[i]) & 0xFF) - (referenceImage[i] & 0xFF));
            diff += Math.abs(((Endorsements.endorse(pixels[i]) >> 8) & 0xFF) - ((referenceImage[i] >> 8) & 0xFF));
            diff += Math.abs(((Endorsements.endorse(pixels[i]) >> 16) & 0xFF) - ((referenceImage[i] >> 16) & 0xFF));
        }
        if (diff > 0) {
            System.err.println("Image check failed! - #errors: " + diff);
        } else {
            System.err.println("Image check passed!");
        }
    }
}
